# Respostas das Questões

## Q1

Versão do crpytography usado: **42.0.3**

## Q2

De acordo com a documentação da library cryptohraphy:
```
- nonce (bytes-like) – Should be unique, a nonce. It is critical to never reuse a nonce with a given key. Any reuse of a nonce with the same key compromises the security of every message encrypted with that key. The nonce does not need to be kept secret and may be included with the ciphertext.
```

Ao utilizar um nonce fixo, deparamo-nos com implicações significativas para a segurança, particularmente em stream ciphers como o ChaCha20.

O nonce é um valor único que, quando combinado com a chave, garante a produção de uma sequência de cifras única. Se um nonce fixo for utilizado, a mesma chave criptográfica produzirá a mesma sequência de cifras para mensagens idênticas.

Isto pode levar a vários problemas de segurança, por exemplo:

1. ***Information Leakage*:** Quando um nonce fixo é utilizado em diferentes mensagens com a mesma chave, padrões na sequência de cifras podem ser identificados. Isto compromete a segurança, visto que um adversário pode inferir informações sobre a estrutura ou o conteúdo das mensagens com base nesses padrões.

2. **Repetição de Cifras:** Se uma parte substancial do *plaintext* for repetida, a sequência de cifras também será repetida. Esta repetição pode revelar informações sobre o conteúdo e introduzir vulnerabilidades.

Em suma, o nonce deve ser único para cada mensagem cifrada com a mesma chave. Utilizar um nonce fixo compromete a propriedade de não repetição e pode levar a vulnerabilidades sérias de segurança. É crucial aderir à recomendação de utilizar um nonce único e imprevisível para cada operação.



# Relatório do Guião da Semana X
Apenas tivemos tempo para realizar o primeiro programa deste guião em tempo de aulas, o trabalho restante foi feito no mesmo dia após o horário escolar.

Nota sobre o chacha20_int_attck.py:
- 





